/*
   this verilog module models a bus with a select on four different
   output values.  note that a unary reduction "and" on the xnor of
   two bitvectors produces a one when the two vectors are equal.
*/

module bus(sel, o);
parameter
	w=8;

input  [1:0] sel;
output [w-1:0] o;
wire   [w-1:0] o;

bufif1 b0[w-1:0] (o, w'h12, {w{ &(sel^~2'b00) }});
bufif1 b1[w-1:0] (o, w'h34, {w{ &(sel^~2'b01) }});
bufif1 b2[w-1:0] (o, w'h56, {w{ &(sel^~2'b10) }});
bufif1 b3[w-1:0] (o, w'h78, {w{ &(sel^~2'b11) }});

endmodule
