//
// four bit carry lookahead adder as described in patterson and hennessey
// 19/08/97ajb
//
module cla4(a,b,cin,d,cout);
input [3:0] a,b;
input cin;
output [3:0] d;
output cout;

wire [3:0] c;

assign #1 g[3] = a[3] & b[3];
assign #1 g[2] = a[2] & b[2];
assign #1 g[1] = a[1] & b[1];
assign #1 g[0] = a[0] & b[0];

assign #1 p[3] = a[3] | b[3];
assign #1 p[2] = a[2] | b[2];
assign #1 p[1] = a[1] | b[1];
assign #1 p[0] = a[0] | b[0];

assign cout = c[3];

assign #2 c[0] = g[0] | (p[0] & cin);

assign #4 c[1] = g[1] | (p[1] & g[0]) | (p[1] & p[0] & cin);    

assign #6 c[2] = g[2] | (p[2] & g[1]) | (p[2] & p[1] & g[0]) |
	(p[2] & p[1] & p[0] & cin);

assign #8 c[3] = g[3] | (p[3] & g[2]) | (p[3] & p[2] & g[1]) |
	(p[3] & p[2] & p[1] & g[0]) |
	(p[3] & p[2] & p[1] & p[0] & cin);

assign #6 d[0] = (a[0] & (~ b[0]) & (~ cin)) |
	((~ a[0]) & b[0] & (~ cin)) |
	((~ a[0]) & (~ b[0]) & cin) |
	(a[0] & b[0] & cin);

assign #6 d[1] = (a[1] & (~ b[1]) & (~ c[0])) |
	((~ a[1]) & b[1] & (~ c[0])) |
	((~ a[1]) & (~ b[1]) & c[0]) |
	(a[1] & b[1] & c[0]);

assign #6 d[2] = (a[2] & (~ b[2]) & (~ c[1])) |
	((~ a[2]) & b[2] & (~ c[1])) |
	((~ a[2]) & (~ b[2]) & c[1]) |
	(a[2] & b[2] & c[1]);

assign #6 d[3] = (a[3] & (~ b[3]) & (~ c[2])) |
	((~ a[3]) & b[3] & (~ c[2])) |
	((~ a[3]) & (~ b[3]) & c[2]) |
	(a[3] & b[3] & c[2]);

endmodule



