#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <math.h>

void sim(void);
extern char t[];

XEvent evt;

/*------------------------------------------------------------------ */
#ifndef ITIMER_REAL              /* fixes compiles on suns and linux */
#define ITIMER_REAL     0
#define ITIMER_VIRTUAL  1
#define ITIMER_PROF     2

struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};


struct  itimerval {
        struct  timeval it_interval;    /* timer interval */
        struct  timeval it_value;       /* current value */
};
#endif
/*------------------------------------------------------------------ */

#define XWIN_SIZE 256
#define YWIN_SIZE 256

struct sigaction Sig;


/* 
 * Globals...
 */
Display *display;
Window window;
Pixmap buffer;
int screen;
GC clear, background;
GC pixor;

#ifdef __linux__
struct sigaction Sig;
#endif


int cycles=0;

int in1, in2, mode, xout, yout, eoln;

void sim2(void)
{

t[29]=(in1>>0)&1;
t[30]=(in1>>1)&1;
t[31]=(in1>>2)&1;
t[32]=(in1>>3)&1;
t[33]=(in1>>4)&1;
t[34]=(in1>>5)&1;
t[35]=(in1>>6)&1;
t[36]=(in1>>7)&1;

t[21]=(in2>>0)&1;
t[22]=(in2>>1)&1;
t[23]=(in2>>2)&1;
t[24]=(in2>>3)&1;
t[25]=(in2>>4)&1;
t[26]=(in2>>5)&1;
t[27]=(in2>>6)&1;
t[28]=(in2>>7)&1;

t[17]=(mode>>0)&1;
t[18]=(mode>>1)&1;

sim();

/*** output section ***/

yout=
((t[8]&1)<<7)|   
((t[7]&1)<<6)|
((t[6]&1)<<5)|
((t[5]&1)<<4)|
((t[4]&1)<<3)|
((t[3]&1)<<2)|
((t[2]&1)<<1)|
((t[1]&1)<<0);

xout=
((t[16]&1)<<7)|
((t[15]&1)<<6)|  
((t[14]&1)<<5)|
((t[13]&1)<<4)|
((t[12]&1)<<3)|
((t[11]&1)<<2)|
((t[10]&1)<<1)|
((t[9]&1)<<0);

eoln=t[19]&1;   
/* printf("xout: %-3d yout: %-3d eoln: %d\n",xout,yout,eoln); */

cycles++;
/*if((cycles&1023)==0) printf("%d\n",cycles);*/

}


void drawline(int x1, int y1, int x2, int y2)
{
in1=x1; in2=x2; mode=0;
sim2(); 
in1=y1; in2=y2; mode=1;
sim2();
mode=2;
sim2();
mode=3;
do	{
	sim2();
	XDrawPoint(display,window,pixor,xout,yout);
	}
	while(!eoln);
}

/*
 * 25Hz screen IRQ...
 */
char init=0;
int lines=0;

void update()
{
int i;

static int x1=10, y1=17, x2=5, y2=23;
static int x1d=3, x2d=5, y1d=4, y2d=3;

while(1)
{
	drawline(x1,y1,x2,y2);
	XFlush(display); 
	x1+=x1d; if((x1<0)|(x1>255)) { x1d=-x1d; x1+=x1d; }
	x2+=x2d; if((x2<0)|(x2>255)) { x2d=-x2d; x2+=x2d; }
	y1+=y1d; if((y1<0)|(y1>255)) { y1d=-y1d; y1+=y1d; }
	y2+=y2d; if((y2<0)|(y2>255)) { y2d=-y2d; y2+=y2d; }

	if(((++lines)&0x7f)==0)
	{
	XCopyArea(display,buffer,window,pixor,0,0,XWIN_SIZE,YWIN_SIZE,0,0);
	XFlush(display);
	}

	while(XCheckMaskEvent(display,EnterWindowMask|LeaveWindowMask,&evt));
}
}


/*
 * Calls all of the X nonsense...
 */
void main(void)
{
struct itimerval time;
XGCValues val;
unsigned long msk;
unsigned long i,j;

XTextProperty wtitle;
char *window_name="Lines";

if((display=XOpenDisplay((char *)0))==(Display *)0)
   {
   fprintf(stdout,"Cannot Open Display!\n");
   exit(0);
   }

screen=DefaultScreen(display);

window=XCreateSimpleWindow(display,RootWindow(display,screen),0,
       0,XWIN_SIZE,YWIN_SIZE, 1, WhitePixel(display,screen), 
WhitePixel(display,screen));

background=XCreateGC(display, window, 0, (XGCValues *)0);
XSetForeground(display,background,WhitePixel(display,screen));

msk=GCFunction;
val.function=GXclear;
clear=XCreateGC(display, window, msk, &val);


val.function=GXcopy;
pixor=XCreateGC(display, window, msk, &val);

XSetForeground(display, pixor, BlackPixel(display,screen));
XSetBackground(display, pixor, BlackPixel(display,screen));

XMapWindow(display, window);
XStringListToTextProperty(&window_name,1,&wtitle);
/* XSetWMName(display,window,&wtitle);  */

XSelectInput(display, window, EnterWindowMask|LeaveWindowMask);
XNextEvent(display, &evt);
XSelectInput(display, window, NoEventMask);

XMapWindow(display, window);
buffer=XCreatePixmap(display,window,XWIN_SIZE,YWIN_SIZE,8);

XFillRectangle(display, buffer, clear, 0, 0, XWIN_SIZE, YWIN_SIZE);
XFillRectangle(display, buffer, background, 0, 0, XWIN_SIZE, YWIN_SIZE);
XFlush(display);




        Sig.sa_handler = update;
        Sig.sa_flags = SA_RESTART;
        sigaction((int)SIGALRM,&Sig,0);

time.it_interval.tv_sec=0;
time.it_interval.tv_usec=40000;  /* make this match your frame rate */
time.it_value.tv_sec=0;
time.it_value.tv_usec=1;

setitimer(ITIMER_REAL, &(time), (struct itimerval *)0);

while(1) { pause(); }
}


